{$N+}
unit lib3d;
Interface
 type
  point3d = Record
  x,y,z:Integer;
  end;
 var
  lib3d_perspective:Boolean;
  lib3d_e:Integer;
 procedure rotate(Ax,Ay,Az:Integer; var p: Point3d);
 procedure transform(pt3d:Point3d;cx,cy:Integer; var x2d,y2d:Integer);
 procedure drawfile3d(filename:String;cx,cy,x1,y1,x2,y2,Ax,Ay,Az:Integer);
Implementation
uses graph;
 const
  gr = pi /180;
 var
  tcos,tsin:array[0..359] of Extended;
  i:Integer;
 procedure rotate(Ax,Ay,Az:Integer; var p: Point3d);
 var
  s1,s2,s3,c1,c2,c3:Extended;
  Puit:Point3d;
 begin
  s1:=tsin[trunc(ax)];
  c1:=tcos[trunc(ax)];
  s2:=tsin[trunc(ay)];
  c2:=tcos[trunc(ay)];
  s3:=tsin[trunc(az)];
  c3:=tcos[trunc(az)];
  puit.x:=trunc(p.x*(c2*c3)+p.y*(c2*s3)-p.z*s2);
  puit.y:=trunc(p.x*(s1*s2*c3-c1*s3)+p.y*(s1*s2*s3+c1*c3)+p.z*(s1*c2));
  puit.z:=trunc(p.x*(c1*s2*c3+s1*s3)+p.y*(c1*s2*s3-s1*c3)+p.z*(c1*c2));
  p:=puit;
 end;
 procedure transform(pt3d:Point3d;cx,cy:Integer; var x2d,y2d:Integer);
 var
  Thit:Real;
 begin
 if lib3d_perspective then
 begin
  Thit:=1/(1-pt3d.x/lib3d_e);
  x2d:= trunc(cx+pt3d.y*thit);
  y2d:= trunc(cy-pt3d.z*thit);
 end
 else
 begin
  x2d:=trunc(cx+round(pt3d.y));
  y2d:=trunc(cy-round(pt3d.z));
 end;
 end;
 procedure linec(x1,y1,x2,y2:Integer; color:byte);
 begin
  setcolor(color);
  line(x1,y1,x2,y2);
 end;
 procedure line3d(point1,point2:Point3d; cx,cy:Integer; color:byte);
 var
  x1,x2,y1,y2:Integer;
 begin
  transform(point1,cx,cy,x1,y1);
  transform(point2,cx,cy,x2,y2);
 end;
 procedure drawfile3d(filename:String;cx,cy,x1,y1,x2,y2,Ax,Ay,Az:Integer);
 var
  f:Text;
  point1,point2:Point3d;
{  a1,b1,c1,a2,b2,c2,}p1,q1,p2,q2:Integer;
  c:Byte;
 begin
 assign(f,filename);
 {$I-}
 reset(f);
 {$I+}
 if ioresult <> 0 then exit;
 while not eof(f) do
  begin
   readln(f,point1.x,point1.y,point1.z,point2.x,point2.y,point2.z,c);
   rotate(Ax,Ay,Az,point1);
   rotate(Ax,Ay,Az,point2);
   transform(point1,cx,cy,p1,q1);
   transform(point2,cx,cy,p2,q2);
  if (((p1 >= x1) and (q1 >= y1) and (p1 <= x2) and (q1 <= y2))
  and ((p2 >= x1) and (q2 >= y1) and (p2 <= x2) and (q2 <= y2))) then
  begin
   setcolor(c);
   line(p1,q1,p2,q2);
  end;
  end;
 close(f);
 end;
begin
{樠}
  for i := 0 to 359 do
  begin
   tsin[i]:=sin(i*gr);
   tcos[i]:=cos(i*gr);
  end;
   lib3d_perspective:=true;
   lib3d_e:=350;
end.